#!/usr/bin/python

import csv
import sys

inputfile = './output/std_mergesort_fanout_data.csv'
if len(sys.argv) > 1:
    inputfile = sys.argv[1]
PDFoutput = './output/PDF_mergesort_fanout.csv'
WSoutput  = './output/WS_mergesort_fanout.csv'
if len(sys.argv) > 3:
    PDFoutput = sys.argv[2]
    WSoutput = sys.argv[3]

rownum = 0
reps = 0
threads = 0
runsize = []
numruns = []
numtasks = 0
sortTime = [[],[]]
mergeTime = [[],[]]
totalTime = [[],[]]
seqSortTime=0

with open(inputfile,'rb') as infile:
    reader = csv.reader(infile)
    for row in reader:
        if rownum == 1:
            threads = int(row[1])
            numtasks = int(row[4])
            reps = int(row[5])
        if rownum == 0:
            header = row
        elif row[0] == 'PDF':
            runsize.append(int(row[2]))
            numruns.append(int(row[3]))
            repMergeTime = 0
            repSortTime = 0
            repTotalTime = 0
            for rep in range(6,2*reps+6,2):
                repSortTime += float(row[rep])/reps
                repMergeTime += float(row[rep+1])/reps
                repTotalTime += (float(row[rep]) + float(row[rep+1]))/reps
            sortTime[0].append(repSortTime)
            mergeTime[0].append(repMergeTime)
            totalTime[0].append(repTotalTime)
        elif row[0] == 'WS':
            repMergeTime = 0
            repSortTime = 0
            repTotalTime = 0
            for rep in range(6,2*reps+6,2):
                repSortTime += float(row[rep])/reps
                repMergeTime += float(row[rep+1])/reps
                repTotalTime += (float(row[rep]) + float(row[rep+1]))/reps
            sortTime[1].append(repSortTime)
            mergeTime[1].append(repMergeTime)
            totalTime[1].append(repTotalTime)
        elif row[0] == 'SEQ':
            repsortTime=0
            for rep in range(6,reps+6):
                repsortTime += float(row[rep])/reps
                seqSortTime = repsortTime
        rownum += 1

#write plot data file
Rows = [['#Scheduler','threads','runsize','numruns','tasks','repetitions','avgsorttime', 'avgmergetime', 'avg totaltime','std speedup']]
for run in range(0,len(numruns)) :
    Rows.append(["PDF", threads, runsize[run], numruns[run], numtasks, reps, sortTime[0][run], mergeTime[0][run], totalTime[0][run], seqSortTime/totalTime[0][run]])
with open(PDFoutput, 'wb') as f:
    writer = csv.writer(f)
    writer.writerows(Rows)
Rows = [['#Scheduler','threads','runsize','numruns','tasks','repetitions','avgsorttime', 'avgmergetime', 'avg totaltime','std speedup']]
for run in range(0,len(numruns)) :
    Rows.append(["WS", threads, runsize[run], numruns[run], numtasks, reps, sortTime[1][run], mergeTime[1][run], totalTime[1][run], seqSortTime/totalTime[1][run]])
with open(WSoutput, 'wb') as f:
    writer = csv.writer(f)
    writer.writerows(Rows)
