#!/usr/bin/python

import csv
import sys

inputfile = './output/std_mergesort_speedup_data.csv'
if len(sys.argv) > 1:
    inputfile = sys.argv[1]
PDFoutput = './output/PDF_mergesort_speedup.csv'
WSoutput  = './output/WS_mergesort_speedup.csv'
if len(sys.argv) > 3:
    PDFoutput = sys.argv[2]
    WSoutput = sys.argv[3]

rownum = 0
reps = 0
threads = []
runsize = 0
numruns = 0
numtasks = 0
singleTsorttime = []
singleTmergetime =[]
singleTtotaltime = []
sortTime = [[],[]]
mergeTime = [[],[]]
totalTime = [[],[]]
seqSortTime=0

with open(inputfile,'rb') as infile:
    reader = csv.reader(infile)
    for row in reader:
        if rownum == 1:
            runsize = int(row[2])
            numruns = int(row[3])
            numtasks = int(row[4])
            reps = int(row[5])
        if rownum == 0:
            header = row
        elif row[0] == 'PDF':
            threads.append(int(row[1]))
            repMergeTime = 0
            repSortTime = 0
            repTotalTime = 0
            for rep in range(6,2*reps+6,2):
                repSortTime += float(row[rep])/reps
                repMergeTime += float(row[rep+1])/reps
                repTotalTime += (float(row[rep]) + float(row[rep+1]))/reps
            sortTime[0].append(repSortTime)
            mergeTime[0].append(repMergeTime)
            totalTime[0].append(repTotalTime)
            if int(row[1]) == 1:
                singleTsorttime.append(repSortTime)
                singleTmergetime.append(repMergeTime)
                singleTtotaltime.append(repTotalTime)
        elif row[0] == 'WS':
            repMergeTime = 0
            repSortTime = 0
            repTotalTime = 0
            for rep in range(6,2*reps+6,2):
                repSortTime += float(row[rep])/reps
                repMergeTime += float(row[rep+1])/reps
                repTotalTime += (float(row[rep]) + float(row[rep+1]))/reps
            sortTime[1].append(repSortTime)
            mergeTime[1].append(repMergeTime)
            totalTime[1].append(repTotalTime)
            if int(row[1]) == 1:
                singleTsorttime.append(repSortTime)
                singleTmergetime.append(repMergeTime)
                singleTtotaltime.append(repTotalTime)
        elif row[0] == 'SEQ':
            repsortTime=0
            for rep in range(6,reps+6):
                repsortTime += float(row[rep])/reps
                seqSortTime = repsortTime
        rownum += 1

#write plot data file
Rows = [['#Scheduler','threads','runsize','numruns','tasks','repetitions','avgsorttime', 'avgmergetime', 'avg totaltime','std speedup','seq sortspeedup','seq merge speedup','seq total speedup']]
for thread in range(0,len(threads)) :
    Rows.append(["PDF", threads[thread], runsize, numruns, numtasks, reps, sortTime[0][thread], mergeTime[0][thread], totalTime[0][thread], seqSortTime/totalTime[0][thread],singleTsorttime[0]/sortTime[0][thread],singleTmergetime[0]/mergeTime[0][thread],singleTtotaltime[0]/totalTime[0][thread]])
with open(PDFoutput, 'wb') as f:
    writer = csv.writer(f)
    writer.writerows(Rows)
Rows = [['#Scheduler','threads','runsize','numruns','tasks','repetitions','avgsorttime', 'avgmergetime', 'avg totaltime','std speedup','seq sortspeedup','seq merge speedup','seq total speedup']]
for thread in range(0,len(threads)) :
    Rows.append(["WS", threads[thread], runsize, numruns, numtasks, reps, sortTime[1][thread], mergeTime[1][thread], totalTime[1][thread], seqSortTime/totalTime[1][thread],singleTsorttime[1]/sortTime[1][thread],singleTmergetime[1]/mergeTime[1][thread],singleTtotaltime[1]/totalTime[1][thread]])
with open(WSoutput, 'wb') as f:
    writer = csv.writer(f)
    writer.writerows(Rows)
