#!/usr/bin/python

import sys
import csv


inputfile = './output/quicksort_speedup_data.csv'
if len(sys.argv) > 1:
    inputfile = sys.argv[1]
PDFoutput = './output/PDF_quicksort_speedup.csv'
WSoutput  = './output/WS_quicksort_speedup.csv'
if len(sys.argv) > 3:
    PDFoutput = sys.argv[2]
    WSoutput = sys.argv[3]

threads = []
inputsize = 0
reps = 0
grainsize = 0
numtasks = 0
blocksize = 0
sortTime = [[],[]]
seqSortTime=0
rownum=0
with open(inputfile,'rb') as infile:
    reader = csv.reader(infile)
    for row in reader:
        if rownum == 1:
            inputsize = int(row[2])
            grainsize = int(row[3])
            numtasks = int(row[4])
            blocksize = int(row[5])
            reps = int(row[6])
        if rownum == 0:
            header = row
        elif row[0] == 'PDF':
            threads.append(int(row[1]))
            repSortTime = 0
            for rep in range(7,reps+7):
                repSortTime += float(row[rep])/reps
            sortTime[0].append(repSortTime)
        elif row[0] == 'WS':
            repSortTime = 0
            for rep in range(7,reps+7):
                repSortTime += float(row[rep])/reps
            sortTime[1].append(repSortTime)
        elif row[0] == 'SEQ':
            repsortTime=0
            for rep in range(7,reps+7):
                repsortTime += float(row[rep])/reps
                seqSortTime = repsortTime
        rownum += 1

#write plot data files
Rows = [['#Scheduler','threads','inputsize','grainsize','number of tasks','blocksize','avg sorttime','std speedup','seq speedup']]
for thread in range(0,len(threads)) :
    Rows.append(["PDF", threads[thread], inputsize, grainsize, numtasks, blocksize, reps, sortTime[0][thread], seqSortTime/sortTime[0][thread],sortTime[0][0]/sortTime[0][thread]])
with open(PDFoutput, 'wb') as f:
    writer = csv.writer(f)
    writer.writerows(Rows)
Rows = [['#Scheduler','threads','inputsize','grainsize','number of tasks','blocksize','avg sorttime','std speedup','seq speedup']]
for thread in range(0,len(threads)) :
    Rows.append(["WS", threads[thread], inputsize, grainsize, numtasks, blocksize, reps, sortTime[1][thread], seqSortTime/sortTime[1][thread],sortTime[1][0]/sortTime[1][thread]])
with open(WSoutput, 'wb') as f:
    writer = csv.writer(f)
    writer.writerows(Rows)
