#ifndef MCL_SEQUENTIAL_SORT
#define MCL_SEQUENTIAL_SORT

#include <algorithm>

#include "MCL/data_structures/subview.h"

namespace mcl{
  
  template<class View, class Compare, class Task>
  class SortTask : public Task {
  public:
    inline SortTask(View* input, Compare cmp) : input_(input,0,input->size()), cmp_(cmp) {}
    inline SortTask(mcl::SubView<View>& input, Compare cmp) : input_(input), cmp_(cmp) {}
    void operator()(){
    if(input_.size() < 1)
      return;
    std::sort(input_.begin(),input_.end(),cmp_);
  }
  private:
    mcl::SubView<View> input_;
    Compare cmp_;
};

}

#endif
