#ifndef MCL_VIEW_DIVISION
#define MCL_VIEW_DIVISION

#include "MCL/data_structures/basicArray.h"
#include "MCL/data_structures/subview.h"

namespace mcl {

  template<class View>
    BasicArray<SubView<View> > BlocksOfAtMost(View& inputView, size_t blocksize){
    unsigned short numBlocks = ceil(inputView.size()/blocksize);
    BasicArray<SubView<View> > ans(numBlocks);
    for(size_t i=0;i<ans.size()-1;++i){
      SubView<View> tmp(&inputView,i*blocksize,(i+1)*blocksize);
      ans[i] = tmp;
    }
    SubView<View> tmp(&inputView,(ans.size()-1)*blocksize,inputView.size());
    ans[ans.size()-1] = tmp;
    return ans;
  }



}

#endif //header guard
